<?php
  /**************************************************************************\
  * phpGroupWare - Setup                                                     *
  * http://www.phpgroupware.org                                              *
  * --------------------------------------------                             *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or at your   *
  *  option) any later version.                                              *
  \**************************************************************************/

  /* $Id: mysql_dropnewtables.inc.php,v 1.1 2001/05/08 16:00:22 camden Exp $ */
  echo 'Dropping Customers table...<br>';
  $phpgw->db->query("DROP TABLE IF EXISTS phpgw_ttrack_customers");
  echo 'Dropping Employee Profiles table...<br>';
  $phpgw->db->query("DROP TABLE IF EXISTS phpgw_ttrack_employee_profiles");
  echo 'Dropping Jobs table...<br>';
  $phpgw->db->query("DROP TABLE IF EXISTS phpgw_ttrack_jobs");
  echo 'Dropping Job Status table...<br>';
  $phpgw->db->query("DROP TABLE IF EXISTS phpgw_ttrack_job_status");
  echo 'Dropping Job Details table...<br>';
  $phpgw->db->query("DROP TABLE IF EXISTS phpgw_ttrack_job_details");
  echo 'Dropping Locations table...<br>';
  $phpgw->db->query("DROP TABLE IF EXISTS phpgw_ttrack_locations");
  echo 'Dropping Work Catagories table...<br>';
  $phpgw->db->query("DROP TABLE IF EXISTS phpgw_ttrack_work_catagories");

  // Additional code to remove TTrack_Managers group, assoc acls,
  // employee_profiles, entries in phpgw_config and phpgw_applications
  	$n_group = "TTrack_Managers";
	if ($phpgw->accounts->exists($n_group))
	{
        // First be sure to remove all users from the group
        $mgrgrpid = $phpgw->accounts->name2id($n_group);
	  // Get the user account id's for members of this group
        $old_group_list = $phpgw->acl->get_ids_for_location(intval($mgrgrpid),1,'phpgw_group');
        @reset($old_group_list);
	  echo 'Removing members from TTrack_Managers group...<br>';
        while($old_group_list && $id = each($old_group_list)) {
	    // Remove the user from this group
          $phpgw->acl->delete_repository('phpgw_group',$mgrgrpid,intval($id[1]));
        }
        // Remove the group's acl right to manage jobs
	  echo 'Removing manage_jobs acl for TTrack_Managers group...<br>';
        $phpgw->acl->delete_repository('timetrack','manage_jobs',intval($mgrgrpid));
        // Finally delete the group
	  echo 'Deleting TTrack_Managers group...<br>';
        $phpgw->accounts->delete($n_group);
	}

  	$n_group = "TTrack_Payroll";
	if ($phpgw->accounts->exists($n_group))
	{
        // First be sure to remove all users from the group
        $paygrpid = $phpgw->accounts->name2id($n_group);
        $old_group_list = $phpgw->acl->get_ids_for_location(intval($paygrpid),1,'phpgw_group');
        @reset($old_group_list);
	  echo 'Removing members from TTrack_Payroll group...<br>';
        while($old_group_list && $id = each($old_group_list)) {
          $phpgw->acl->delete_repository('phpgw_group',$paygrpid,intval($id[1]));
        }
	  echo 'Removing manage_jobs acl for TTrack_Payroll group...<br>';
	  $phpgw->acl->delete_repository('timetrack','manage_payroll',intval($paygrpid));
	  echo 'Deleting TTrack_Payroll group...<br>';
        $phpgw->accounts->delete($n_group);
	}

	// Get the list of users with run acl for this app
      $old_group_list = $phpgw->acl->get_ids_for_location('run',1,'timetrack');
	echo 'Removing Timetrack run acl for all users...<br>'; 
      @reset($old_group_list);
      while($old_group_list && $id = each($old_group_list)) {
	  // Delete the run acl for timetrack from the assoc. users acls
        $phpgw->acl->delete_repository('timetrack','run',intval($id[1]));
      }

  // Finally, remove the entry from the applications table:
  echo 'Removing Timetrack from the applications table...<br>';
  $phpgw->db->query("DELETE from phpgw_applications where app_name = 'timetrack'");

?>