<?php

//$phpgw_info['flags']['currentapp']='wcm';
//$phpgw_info['flags']['noheader']=True;
//include("../header.inc.php");

/**
 * Create and edit data on phpWebSite main page.
 *
 * @author Adam Morton <am26882@appstate.edu>
 * @module 
 * @modulegroup administration
 * @package phpWebSite
 */

/**
 * Gets data from user to populate main page.
 */
function main_page_data()
{
	global $phpgw;
  /**
   * Generates page header.
   */
	$phpgw->common->phpgw_header();
	include("header.php");
	GraphicAdmin(0);
	$phpgw->db->query("select main_title, main_text, main_image, alt, active from wcm_main_page_content");
	$phpgw->db->next_record();
	$main_title=$phpgw->db->f("main_title");
	$main_text=$phpgw->db->f("main_text");
	$main_image=$phpgw->db->f("main_image");
	$main_alt=$phpgw->db->f("alt");
	$active=$phpgw->db->f("active");

        $main_title = stripslashes($main_title);
        $main_text = stripslashes($main_text);
        $main_alt = stripslashes($main_alt);

	$box_title = lang("Populate Main Page");
	$box_stuff = "<form action=\"admin.php\" method=\"post\" enctype=\"multipart/form-data\">

<table align=\"center\" cellspacing=\"10\">
<tr><td class=\"type5\" align=\"left\" colspan=\"2\">";

	if($active){ 
		$box_stuff .= "<input type=\"checkbox\" name=\"active\" value=\"1\" checked=\"checked\" />";
	}
	else{ 
		$box_stuff .= "<input type=\"checkbox\" name=\"active\" value=\"1\" />";
	}

	$box_stuff .= lang("Make this content active")."?
</td></tr>

<tr><td class=\"type5\" valign=\"top\" align=\"left\" width=\"50%\">
	".lang("Main Title").": <br />
	<input type=\"text\" name=\"main_title\" value=\"$main_title\" maxlength=\"60\" size=\"33\" />
        <br />
        ".lang("Main Text").": <br />
	<textarea name=\"main_text\" cols=\"28\" rows=\"20\" wrap=\"soft\">";
	$convertedcontents = htmlspecialchars($main_text);
	$box_stuff .= "$convertedcontents";
	$box_stuff .= "</textarea><br />

	".lang("Main Image").": <br />";

	if($main_image != "none"){
		$box_stuff .= "<img src=\"$main_images_webdir$main_image\" alt=\"$main_alt\" /><br />
        	<input type=\"hidden\" name=\"old_main_image\" value=\"$main_image\" />
        	<input type=\"file\" name=\"main_image\" maxlength=\"60\" size=\"25\" />
        	<br />
        	".lang("Short Image Description").":<br />
        	<input type=\"text\" name=\"main_alt\" maxlength=\"60\" size=\"33\" value=\"$main_alt\" />";
	}
	else{
		$box_stuff .= "<input type=\"file\" name=\"main_image\" maxlength=\"60\" size=\"25\" />
        	<br />
		<input type=\"hidden\" name=\"old_main_image\" value=\"0\" />
        	".lang("Short Image Description").":<br />
        	<input type=\"text\" name=\"main_alt\" maxlength=\"60\" size=\"33\" value=\"$main_alt\" />";
	}

	$box_stuff .= "</td></tr><tr>
	<td class=\"type5bigger\" colspan=\"2\" align=\"left\">
	<input type=\"hidden\" name=\"op\" value=\"submit_main_page\" />
	<input type=\"submit\" value=\"".lang("Submit")."\" />
</td></tr>
</table>

	</form>";
themesidebox($box_title, $box_stuff);
	
  /**
   * Generates page footer.
   */
	include ('footer.php');
}

function update_main_page($main_title, $main_text, $main_image, $main_alt, $main_image_name, $main_image_type, $main_image_size, $active)
{
	global $phpgw;
  /**
   * Defines core functions.
   */
	include("config.php");

	if($main_image != 'none')
	{
		if($main_image_size > $max_user_file_size)
		page_error("$image_name / $level : ".lang("The image in the section is too large.")." <br />
	                  ".lang("The largest allowable size is:")." $max_user_file_size bytes.<br />
		          ".lang("Your file is:")." $main_image_size bytes.");

		if(substr_count($user_file_types, $main_image_type)>0)
		{
			if(copy($main_image, $main_page_images.$main_image_name))
			$phpgw->db->query("update wcm_main_page_content set main_title='$main_title', main_text='$main_text', main_image='$main_image_name', alt='$main_alt', active='$active'");
			else
			page_error("$image_name / $level : ".lang("The image did not load sucessfully.  Please try again.")."<br />");
		}
		else
		page_error("$image_name / $level : ".lang("The image in the section has a wrong file type.")."<br />
	                  ".lang("The allowed types are").": $user_file_types<br />
			  ".lang("You file is of type").": $main_image_type");
	}
	else
	{
		$phpgw->db->query("update wcm_main_page_content set main_title='$main_title', main_text='$main_text', main_image='$main_image_name', alt='$main_alt', active='$active'");
	}
}

function test_main_page_data()
{
	global $phpgw;
	
  /**
   * Generates page header.
   */
	$phpgw->common->phpgw_header();
	include ("header.php");
	GraphicAdmin(0);

	echo "
<table border=\"0\" width=\"100%\" cellpadding=\"0\" cellspacing=\"1\">
<tr>
	<td class=\"type0\">
<table border=\"0\" width=\"100%\" cellpadding=\"8\" cellspacing=\"0\">
<tr>
	<td class=\"type5bigger\">
	<center>".lang("Testing Data Entry")."</center>
	</td>
</tr>
<tr>
	<td class=\"type5bigger\">
<table align=\"center\" cellspacing=\"10\">
	";
	
	$phpgw->db->query("select main_title, main_text, main_image, alt from main_page_content");
	$phpgw->db->next_record();
	$main_title=$phpgw->db->f("main_title");
	$main_text=$phpgw->db->f("main_text");
	$main_image=$phpgw->db->f("main_image");
	$main_alt=$phpgw->db->f("alt");

	echo "
<tr>
        <td class=\"type5bigger\">".lang("Main Title").": $main_title</td>
</tr>
<tr>
        <td class=\"type5bigger\">".lang("Main Text").": $main_text</td>
</tr>
<tr>
        <td class=\"type5bigger\">".lang("Main Image").": $main_image</td>
</tr>
</table>
</td></tr></table>
</td></tr></table>
	";
		
  /**
   * Generates page footer.
   */
	include ('footer.php');
}

?>
